#ifndef SEQUENCE_OPERATIONS_H
#define SEQUENCE_OPERATIONS_H

#include <string>
#include <algorithm>
#include "const_include.h"

using namespace std;

inline string reverse_comp(string &s) {
	string temp = "";
	int len = s.length();
	
	for(int i=1; i<=len; i++) {
		switch(s[len-i]) {
			case 'a':
				temp += 't';
				break;
			case 't':
				temp += 'a';
				break;
			case 'c':
				temp += 'g';
				break;
			case 'g':
				temp += 'c';
				break;
			case '-':
				temp += '-';
				break;
			default:
				temp += 'n';
				break;
		}
	}
	
	return temp;
} 

inline void reverse_comp(float** pwm, unsigned int length) {
	float temp_pwm[length][4];


	//for(r_vit = v.rbegin(); r_vit != v.rend(); ++r_vit) {
	for(unsigned int i = 0; i < length; ++i) {
		//need to switch places with the characters: a-t, g-c
		//also need to rev-com it.
		temp_pwm[length-1-i][A_POS] = pwm[i][T_POS];
		temp_pwm[length-1-i][C_POS] = pwm[i][G_POS];
		temp_pwm[length-1-i][G_POS] = pwm[i][C_POS];
		temp_pwm[length-1-i][T_POS] = pwm[i][A_POS];
	}
		
	for(unsigned int i=0; i<length; i++) {
		for(unsigned int j=0; j<4; j++) {
			pwm[i][j] = temp_pwm[i][j];
		}
	}
	
	//cout << "temp's size: " << temp.size() << endl;
	//cout << "originals size: " << v.size() << endl; 
}

inline float** reverse_comp_cpy(float** pwm, unsigned int length) {
	float** temp_pwm = new float*[length];

	for(unsigned int i=0; i<length; i++) {
		temp_pwm[length-1-i] = new float[4];
		temp_pwm[length-1-i][A_POS] = pwm[i][T_POS];
		temp_pwm[length-1-i][C_POS] = pwm[i][G_POS];
		temp_pwm[length-1-i][G_POS] = pwm[i][C_POS];
		temp_pwm[length-1-i][T_POS] = pwm[i][A_POS];
	}

	return temp_pwm;
}


inline float** reverse_comp_cpy_n(float** pwm, unsigned int length) {
	float** temp_pwm = new float*[length];

	for(unsigned int i=0; i<length; i++) {
		temp_pwm[length-1-i] = new float[4];
		temp_pwm[length-1-i][A_POS] = pwm[i][T_POS];
		temp_pwm[length-1-i][C_POS] = pwm[i][G_POS];
		temp_pwm[length-1-i][G_POS] = pwm[i][C_POS];
		temp_pwm[length-1-i][T_POS] = pwm[i][A_POS];
		temp_pwm[length-1-i][N_POS] = pwm[i][N_POS];
	}

	return temp_pwm;
}

inline unsigned int max_flt(float array[], unsigned int array_size) {
	float* pos = max_element(array, array+array_size);
	unsigned int max_pos = pos - &array[0];
	return max_pos;
}

inline string str2qual(Read &r) {
	string qual;
	qual.reserve(r.length+1);

	unsigned int i;
	for(i=0; i<r.length; i++) {
		int max_pos = max_flt(r.pwm[i],4);
		qual[i] = (char)((-10 * log(1-r.pwm[i][max_pos])/log(10))+33);
	}
	qual[i] = '\0';

	return qual;
}


#endif
