#ifndef CONST_INCLUDE_H
#define CONST_INCLUDE_H

#include <cmath>
typedef unsigned long long BIT64_t;

//If it's wanted to have a base-pair resolution, un-comment these lines and comment the next two.
// NOTE:  CANNOT CHANGE THIS TYPE WITHOUT RUINING MPI
typedef unsigned int GEN_TYPE;
#define GEN_PACK	8

extern unsigned int gGEN_SIZE;

#define MAX_MISMATCH 100

// This flag will include a lot of verbose output.
//#define DEBUG

#define MAX_LN_SZ	1024

#define A_POS 0
#define C_POS 1
#define G_POS 2
#define T_POS 3
#define N_POS 4

/******** Needed for Probcons *********/
//int VERSION = 1;
const int NumInsertStates = 2;
/**************************************/

extern unsigned char g_bs_CONVERSION[256];
extern unsigned char g_gen_CONVERSION[256];

extern unsigned char gINT2BASE[16];
extern int gVERBOSE;
extern int gMER_SIZE;
extern unsigned int gBUFFER_SIZE;
extern unsigned int gREAD_BUFFER;
extern unsigned int gHASH_SIZE;
extern unsigned int gMAX_HASH_SIZE;

extern float gALIGN_SCORE;
extern float gALIGN_SCORES[256][4];
extern int gMAX_GAP;
extern float gGAP;
extern int gGEN_SKIP;
extern unsigned int gBISULFITE;
extern unsigned int gATOG;
extern unsigned int gSNP;

extern int gBIN_SIZE;

extern char* g_adaptor;
extern float gMIN_ADAPTOR_DIFF;
extern unsigned int gMIN_CHOPPED_BASES;

extern bool gILLUMINA;

extern bool gSAVE;
extern bool gREAD;
extern char* gSAVE_FN;
extern char* gREAD_FN;

enum FileType {
	CHROM=0,
	SEQUENCE=1
};

enum SeqType {
	INT,
	PRB,
	FASTA,
	FASTQ
};

struct Read {
	char* name;
	Read() { name = 0; length=0; }
	
	Read(float** p, int l) {
		pwm = p; length = l;
	}

	unsigned int length;
	float** pwm;

};

struct GenomeLocation {
	GenomeLocation() {
		amount = 0.0;
		packed_char = 0;
	}

	GenomeLocation(GEN_TYPE pc, float amt)
		: amount(amt), packed_char(pc) {}

	float amount;
	GEN_TYPE packed_char;
};

struct TopReadOutput {
	char READ_NAME[100];
	char CHR_NAME[100];
	unsigned long CHR_POS;
	bool strand;
	int MAPQ;
	char CIGAR[100];
	unsigned int readIndex;
};

/**********************************************
 * These next are for Command-Line Parsing
 **********************************************/
#define INVALID_ARG -1
#define NO_MATCHING_ARG -2
#define UNKNOWN_ARG -3
#define PARSE_ERROR -10

struct CMDLine {
	int errnum;
	int errpos;
};
/**********************************************/


#endif //CONST_INCLUDE_H
