#ifndef HASH_MAP_H
#define HASH_MAP_H

#include "const_include.h"

template <typename KEY_TYPE, class MAP_TYPE>
class hash_map {
	public:
		hash_map<KEY_TYPE, MAP_TYPE>():
			num_elements(0), max_size(DEFAULT_SIZE) {
			//_hash_map = new MAP_TYPE[max_size];
			_hash_map = NULL;
			Init(DEFAULT_SIZE);
		}
		
		hash_map<KEY_TYPE, MAP_TYPE>(unsigned long size) :
			num_elements(0), max_size(size) {
			//_hash_map = new MAP_TYPE[size];
			_hash_map = NULL;
			Init(size);
		}

		~hash_map<KEY_TYPE, MAP_TYPE>(){
			delete[] _hash_map;
		}

		/*
		MAP_TYPE& operator[](KEY_TYPE &hash_spot) {
			if(static_cast<unsigned long>(hash_spot) > max_size)
				resize(max_size * 10);
		
			return _hash_map[static_cast<unsigned long>(hash_spot)];
		}
		*/
		
		MAP_TYPE& operator[](KEY_TYPE hash_spot) {
			if(static_cast<unsigned long>(hash_spot) > max_size)
				resize(max_size * 10);
		
			return _hash_map[static_cast<unsigned long>(hash_spot)];
		}

		void set_size(unsigned long new_size) {
			resize(new_size);
		}
		
		unsigned long size() {
			return max_size;
		}

		void clear() {
			Init(DEFAULT_SIZE);
		}

	private:
		void resize(unsigned long new_size) {
			//if(gVERBOSE > 1) fprintf(stderr,"HASH_MAP: Calling resize()\n");
			MAP_TYPE* hash_temp = new MAP_TYPE[new_size];
			for(unsigned long i=0; i<max_size && i<new_size; i++)
				hash_temp[i] = _hash_map[i];
				
			if(_hash_map)
				delete[] _hash_map;
			_hash_map = hash_temp;
			max_size = new_size;
		}

		void Init(unsigned long size) {
			num_elements = 0;
			max_size = size;
			if(_hash_map)
				delete[] _hash_map;
			_hash_map = new MAP_TYPE[size];
		}
	
		MAP_TYPE* _hash_map;
		unsigned long num_elements;
		unsigned long max_size;

		static const unsigned long DEFAULT_SIZE=100;
};


#endif //HASH_MAP_H
