// pairHMM
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <stdlib.h>

#define A_POS 0
#define C_POS 1
#define G_POS 2
#define T_POS 3

float p(char x, char y) {
	if(x == y) return 10*4/5; else return 10*1/5;
}

float p_seq(float x[4], char y) {
	float sum = 0;
	sum += x[A_POS] * p('a',tolower(y));
	sum += x[C_POS] * p('c',tolower(y));
	sum += x[G_POS] * p('g',tolower(y));
	sum += x[T_POS] * p('t',tolower(y));
	return sum;
}

int main(const int argc, const char* argv[]) {
	int x_size = 35;
	int i,j;
	float sum,denom;
	int SEQ_STYLE=0;

	if(argc > 1)
		SEQ_STYLE = atoi(argv[1]);

	if(SEQ_STYLE)
		fprintf(stderr,"Using Sequences, not READ\n");
	else
		fprintf(stderr,"Using float READs, not sequences\n");

	float** x = (float**)malloc(sizeof(float*) * x_size);
	for(i=0; i<x_size; i++) {
		x[i] = (float*)malloc(sizeof(float) * 4);
	}
	int row = 0;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 1.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 1.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.6; x[row][2] = 0.4; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 1.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 1.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 0.0; x[row][2] = 1.0; x[row][3] = 0.0; row++;
	x[row][0] = 1.0; x[row][1] = 0.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;
	x[row][0] = 0.0; x[row][1] = 1.0; x[row][2] = 0.0; x[row][3] = 0.0; row++;

	char* x_str = "CAGATGAGACTGCGCACGAAGTCGCCGTAACGACC";
	//char* x_str = "CAGATGAGACTGGGCACGAAGTCGCCGTAACGACC";
	assert(strlen(x_str) == x_size);
	int n = strlen(x_str);
	float finX[n];
	char* y_str = "CAGATGAGACTGGGCACGAAGTCGCCGTAACGACC";
	//char* y = "TCAATGAACA";
	int m = strlen(y_str);
	float finY[m];

	// Emissions
	float q = .25;	// if in a gap state, equal prob of ACGT

	// transitions
	float t = 0.05; //Trans to end state
	float d = 0.1; //P(M->X,Y)
	float e = 0.5; //P(X,Y->M)
	float Tmm = 1-2*d-t;
	float Tgm = 1-d-t;
	float Tmg = d;
	float Tgg = e;

	// Forward
	// Create Matrices
	float fM[n+1][m+1];
	float fX[n+1][m+1];
	float fY[n+1][m+1];
	// backward matrices
	float bM[n+1][m+1];
	float bX[n+1][m+1];
	float bY[n+1][m+1];
	
	// final matrices
	float pM[n][m];
	float pMX[n][m];
	float pMY[n][m];
	float pX[n][m];
	float pY[n][m];

	// set them to zero
	for(i=0; i<n+1; i++) {
		for(j=0; j<m+1; j++) {
			fM[i][j] = 0;
			fX[i][j] = 0;
			fY[i][j] = 0;

			bM[i][j] = 0;
			bX[i][j] = 0;
			bY[i][j] = 0;

		}
	}
	for(i=0; i<n; i++) {
		for(j=0; j<n; j++) {
			pM[i][j] = 0;
			pMX[i][j] = 0;
			pMY[i][j] = 0;
			pX[i][j] = 0;
			pY[i][j] = 0;
		}
	}

	// NOTE:  Indices are different because R is 1-based
	fM[0][0] = 1;

	// Forward

	for(i=1; i<n+1; i++) {
		for(j=1; j<m+1; j++) {
if(SEQ_STYLE)
			fM[i][j] = p(x_str[i-1],y_str[j-1]) * (Tmm*fM[i-1][j-1] + Tgm*fX[i-1][j-1] + Tgm*fY[i-1][j-1]);
else
			fM[i][j] = p_seq(x[i-1],y_str[j-1]) * (Tmm*fM[i-1][j-1] + Tgm*fX[i-1][j-1] + Tgm*fY[i-1][j-1]);

			fX[i][j] = q*(Tmg*fM[i-1][j]+Tgg*fX[i-1][j]);
			fY[i][j] = q*(Tmg*fM[i][j-1]+Tgg*fY[i][j-1]);
		}
	}

	float fE=t*(fM[n][m]+fX[n][m]+fY[n][m]);

	// Backward

	bM[n-1][m-1] = bX[n-1][m-1] = bY[n-1][m-1] = t;

	for(i=n-1; i>=0; i--) {
		for(j=m-1; j>=0; j--) {
			if(j == (m-1) && i == (n-1))
				continue;
			if(j == m-1) {
				bM[i][j] = q*Tmg*bX[i+1][j];
				bX[i][j] = q*Tgg*bX[i+1][j];
				bY[i][j] = 0;
				continue;
			}
			if(i == n-1) {
				bM[i][j] = q*Tmg*bY[i][j+1];
				bY[i][j] = q*Tgg*bY[i][j+1];
				bX[i][j] = 0;
				continue;
			}
			
if(SEQ_STYLE)
			bM[i][j]= p(x_str[i+1],y_str[j+1])*Tmm*bM[i+1][j+1] + q*Tmg*bX[i+1][j] + q*Tmg*bY[i][j+1];
else
			bM[i][j]= p_seq(x[i+1],y_str[j+1])*Tmm*bM[i+1][j+1] + q*Tmg*bX[i+1][j] + q*Tmg*bY[i][j+1];
if(SEQ_STYLE)
			bX[i][j]= p(x_str[i+1],y_str[j+1])*Tgm*bM[i+1][j+1] + q*Tgg*bX[i+1][j];
else
			bX[i][j]= p_seq(x[i+1],y_str[j+1])*Tgm*bM[i+1][j+1] + q*Tgg*bX[i+1][j];
if(SEQ_STYLE)
			bY[i][j]= p(x_str[i+1],y_str[j+1])*Tgm*bM[i+1][j+1] + q*Tgg*bY[i][j+1];
else
			bY[i][j]= p(x_str[i+1],y_str[j+1])*Tgm*bM[i+1][j+1] + q*Tgg*bY[i][j+1];

		}
	}

	for(i=1; i<n+1; i++) {
		for(j=1; j<m+1; j++) {
			pM[i-1][j-1] = fM[i][j]*bM[i-1][j-1]/fE;
			pX[i-1][j-1] = fX[i][j]*bX[i-1][j-1]/fE;
			pY[i-1][j-1] = fY[i][j]*bY[i-1][j-1]/fE;
			//pM[i-1][j-1] = fM[i][j]*bM[i-1][j-1];
			//pX[i-1][j-1] = fX[i][j]*bX[i-1][j-1];
			//pY[i-1][j-1] = fY[i][j]*bY[i-1][j-1];
		}
	}

	/*
	for(i=0; i<n+1; i++) {
		for(j=0; j<m+1; j++) {
			printf("%.2f\t",pM[i][j]);
		}
		printf("\n");
	}
	printf("\n");
	//*/

	//apply(pM+pX,1,sum)
	//apply(pM+pY,2,sum)
	for(i=0; i<n; i++) {
		for(j=0; j<m; j++) {
			pMX[i][j] = pM[i][j] + pX[i][j];
			pMY[i][j] = pM[i][j] + pY[i][j];
		}
	}

	for(i=0; i<n; i++) {
		sum = 0;
		for(j=0; j<m; j++) {
			sum += pMX[i][j];
		}
		finX[i] = sum;
	}
	
	for(j=0; j<m; j++) {
		sum = 0;
		for(i=0; i<n; i++) {
			sum += pMY[i][j];
		}
		finY[j] = sum;
	}

	// Print out X
	for(i=0; i<n; i++) {
		printf("%c\t",x_str[i]);
	}
	printf("\n");
	for(i=0; i<n; i++) {
		printf("%.3f\t",finX[i]);
	}
	printf("\n");
	// Print out Y
	for(i=0; i<n; i++) {
		printf("%c\t",y_str[i]);
	}
	printf("\n");
	for(i=0; i<n; i++) {
		printf("%.3f\t",finY[i]);
	}
	printf("\n");

	sum = 0;
	denom = 0;
	for(i=0; i<n; i++) {
		denom += pM[i][12] + pX[i][12];
	}
	for(i=0; i<m; i++) {
		if(y_str[i] == 'G')
			sum += pM[i][12];
	}
	printf("At position %d, %c is %f\n",1,'A',sum/denom);
}
