#include "NormalScoredSeq.h"

string NormalScoredSeq::print_full(double denom, Genome &gen, Read &read) const {
	ostringstream temp;
	double total_score = log_align_score / denom;
	temp << align_score << "\t" << log_align_score << "\t" << positions.size() << "\t" << total_score << "\t" << sequence << "\t";
		
	set<pair<unsigned long,bool> >::iterator sit;
	
	for(sit = positions.begin(); sit != positions.end(); sit++)
		temp << "\t" << gen.GetPos(*sit);
		
	return temp.str();
}

string NormalScoredSeq::print_and_score(double denom, Genome &gen) const {

	ostringstream temp;
	double total_score = log_align_score / denom;
	//temp << align_score << "\t" << log_align_score << "\t" << positions.size() << "\t" << total_score << "\t" << sequence << "\t";
	temp << align_score << "\t" << "\t" << positions.size() << "\t" << total_score << "\t" << sequence;
	
	set<pair<unsigned long,bool> >::iterator sit;
	
	for(sit = positions.begin(); sit != positions.end(); sit++) {
		temp << "\t" << gen.GetPos(*sit);
		gen.AddScore( (*sit).first,total_score );
	}
		
	return temp.str();
}

void NormalScoredSeq::score(double denom, Genome &gen, unsigned int len, Read &read, pthread_mutex_t &lock) {

	double total_score = log_align_score / denom;
	//set<pair<unsigned int,bool> >::iterator sit;
	set<pair<unsigned long,bool> >::iterator sit;
		
	pthread_mutex_lock(&lock);
	for(sit=positions.begin(); sit!=positions.end(); sit++)
		for(unsigned int i=0; i<len; i++) 
			gen.AddScore( (*sit).first+i,total_score );
	pthread_mutex_unlock(&lock);
}
